/*
								+---------------------------------+
								|                                 |
								| ***  Fullscreen GDI Xample  *** |
								|                                 |
								|  Copyright  -tHE SWINe-  2002  |
								|                                 |
								|             Main.cpp            |
								|                                 |
								+---------------------------------+
*/

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include "GDI_Interface.h"
#include "Vectorz.h"
#include "main.h"

static int nWidth, nHeight;
static unsigned __int32 *vid;

void Init_Cfg()
{
    FILE *cfg_file;

	nWidth = 320;
	nHeight = 200;
	// default

	if((cfg_file = fopen("System.ini", "r")) == NULL)
		return;

	fscanf(cfg_file, "%d %d", &nWidth, &nHeight);
	// precte rozliseni z ini

	fclose(cfg_file);
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdline, int nCmdShow)
{
	static char szAppName[] = "GDI test";
	HWND hwnd;
	MSG msg;
	WNDCLASSEX wndclass;

	wndclass.cbSize = sizeof(wndclass);
	wndclass.style = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc = Wokno;
	wndclass.cbClsExtra = 0;
	wndclass.cbWndExtra = 0;
	wndclass.hInstance = hInstance;
	wndclass.hIcon = LoadIcon(hInstance, IDI_APPLICATION);
	wndclass.hCursor = LoadCursor (NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName = 0;
	wndclass.lpszClassName = szAppName;
	wndclass.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
	RegisterClassEx(&wndclass);

	Init_Cfg();
	// nahraje nastaveni

	hwnd = CreateWindowEx(WS_EX_TOPMOST,
		szAppName, "GDI test", WS_POPUP,
		0, 0, nWidth, nHeight, NULL, NULL, hInstance, NULL);
	// vytvori okno vzdy nahore

	if(!Init_GDI_Interface(nWidth, nHeight))
		return 0;
	// pripravi interface pro nase rozliseni

	Vectorz_Init(nWidth, nHeight);

	if((vid = (unsigned __int32*) malloc(nWidth * nHeight * 4)) == NULL)
		return 0;
	// naalokuje video-buffer

	SetTimer(hwnd, 0, 20, NULL);
	// nastavi timer (50 FPS)

	Go_FullScreen();
	// prepne do fullscreen (zkusi to)

	ShowWindow(hwnd, nCmdShow);
	UpdateWindow(hwnd);
	// pokud ukaze okno az po prepnuti do
	// fullscreen, nebude videt lista start

	while(GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage (&msg);
		DispatchMessage (&msg);
	}

	Terminate_GDI_Interface();
	// uvolni trochu pameti

	Vectors_Terminate();
	// a jeste trochu

	free((void*)vid);
	// uvolni video-buffer

	Back_FullScreen();
	// vrati se z fullscreen modu

	return msg.wParam;
}

LRESULT CALLBACK Wokno(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	HDC hdc;

	switch(iMsg) {
	case WM_KEYDOWN:
		if(wParam == VK_ESCAPE)
			SendMessage(hwnd, WM_CLOSE, 0, 0);
		// na esc ukonci program
		return 0;

	case WM_PAINT :
		hdc = BeginPaint(hwnd, &ps);
		// najde kontext naseho okna

		Vectorz_Draw(vid);
		Draw_Bitmap(hdc, vid);
		// a nakresli na nej bitmapu

		EndPaint(hwnd, &ps);
		// skonci kreleni  tim se to zobrazi
		return 0;

	case WM_TIMER :
		InvalidateRect(hwnd, NULL, FALSE);
		// vola WM_PAINT
		return 0;

	case WM_DESTROY :
		PostQuitMessage (0) ;
		return 0 ;
	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;
}


